package dsnserver;

/**********************************************
 * It is for parsing the ProgInfo messages 
 * which are sent back due to a ProgInfo request. 
 * It is used to update the dsninfo table which 
 * shows all DSNnode which was seen since the 
 * DSNServer has started.  
 *  
 * @author kaltt
 *
 **********************************************/
public class CmdParserDSNProgInfo implements CmdParser{

	private String DSNID;
	
	public CmdParserDSNProgInfo() {
		super();
		// TODO Auto-generated constructor stub
	}

	
	/**********************************************
	 * It is responsible for the lines which start
	 * with ":DP". It parses the ProgInfo and write it
	 * to the DB, if this DSNID doesn't already exist,
	 * otherwise it will update the existing row with 
	 * the new time and location. 
	 *  
	 * @param String line
	 *
	 **********************************************/
	public void parseLine(String line){
		int num = 0;
		line = line.replaceAll("'","''");
		String[] token = line.split(" ");
		
		if (token[0].equals(":XP") && token.length == 2){
			token[1]=token[1].trim();
			if (token[1].contains(":") && (token[1].length()==5 || token[1].length()==17)){
				if (token[1].length()<=5) {DSNID = CmdParserGetAddr.DSNpreAddr + token[1];DSNID = DSNID.trim();} else {DSNID = token[1].trim();}
				Parser.setParserState(this);				
			}
		}
		else if (Parser.getParserState() == this){	
			SQLDBcommunication.lock();
			num = SQLDBcommunication.sendQueryToDB("" +
					"UPDATE `dsninfo` SET " +
					"`DSNProgInfo` = '" + line.trim() + "' ," +
					"`DSNlastSeen` = NOW( ) " +
					"WHERE `DSNID` = '"+ DSNID +"';");
			SQLDBcommunication.unlock();
			if (num == 0){
				SQLDBcommunication.lock();
				num = SQLDBcommunication.sendQueryToDB("" +
						"INSERT INTO `dsninfo` " +
						"(`DSNID` , `DSNProgInfo` ,`DSNlastSeen` )" +
						"VALUES ('"+ DSNID +"', '" + line.trim() + "', NOW( ));");
				SQLDBcommunication.unlock();
			}
			Parser.resetParserState();
		}
	}

}
