package dsnserver;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**********************************************
 * It is for parsing the log messages 
 * which comes from all BTnodes and it 
 * will store it into the DB.
 * When the DB table has no entry of a specific 
 * node we will request all logs of this node. 
 * After that we are looking for the last msgID
 * an request all log messages which are newer 
 * than the last msgID in the DB.
 * 
 * @author  kaltt
 **********************************************/
public class CmdParserLogging implements CmdParser{
boolean test = true;
	String DSNID;
	int MsgID;
	String FragNr;
	String SLTime;
	String SLClass;
	String SLLevel;
	String LogText;
	String LineT = "" ;
	DSNtimetoTime dsnTime;
	boolean dropit = false;
	boolean exists = false;

	public static class dsn{
		Long lastlogtime;
		Hashtable<String,Object> log = new Hashtable<String,Object>();
		public @SuppressWarnings("unchecked") List<Integer> received = new ArrayList();
		public @SuppressWarnings("unchecked") List<Integer> request = new ArrayList();
		Hashtable<Integer,Integer> requested = new Hashtable<Integer,Integer>();
		int BootCount = 0;
	}
	
	@SuppressWarnings("unchecked")
	public static HashMap<String,dsn> DSN = new HashMap();


	public CmdParserLogging(DSNtimetoTime dsnTime) {	
		super();
		this.dsnTime = dsnTime;
	}

	
	@SuppressWarnings("unchecked")
	public void parseLine(String line){
		//line = line.trim();
		line = line.replaceAll("'","''");
		String[] token = line.split(" ");
		int end = line.indexOf(0x04);
		int br = line.indexOf(0x03);

		ThreadLogging.lock();
		if (Parser.getParserState() != this){
//System.out.println("State 1");			
			/**********************************************
			 * If a :SL is detected it is going into this 
			 * section. Here it parses the variables 
			 * SLTime, SLClass and SLLevel,
			 * which are used afterwards.
			 * Additionally ParserState is set to ":SL" that
			 * the Parser knows that the next line is for 
			 * this CMDParser as well.
			 **********************************************/
//			Regular Expression if something occurs with something else then numbers
			Pattern p_SL = Pattern.compile(":SL [A-Fa-f0-9]{2}:[A-Fa-f0-9]{2} [0-9]{1,5} [0-9]{1,3} [0-9]{1,10} [0-9]{1,10} [0-9]{1,10}");
			Matcher m_SL = p_SL.matcher(line.trim());
			if (m_SL.matches() && token.length == 7){
//			if (token.length == 7 && token[1].contains(":")){
				Parser.setParserState(this);
				//if (!(token[0].equals(":SL"))){System.exit(0);}
				if (token[1].length()<=5) {DSNID = CmdParserGetAddr.DSNpreAddr + token[1];}else {DSNID = token[1];}
				MsgID = Integer.parseInt(token[2]);
				FragNr = token[3];
				SLTime = token[4];
				if (SLTime.contains(":")){
					SLTime = SLTime.replaceAll(":", "");
					SLTime = SLTime.trim();
				}
				SLClass = token[5];
				SLLevel = token[6].trim();
				LineT = "";	
				exists = false;dropit=false;				
				
				//Regular Expression if something occurs with something else then numbers
				Pattern p = Pattern.compile(".*[^0-9]+.*");
				Matcher m_MsgID = p.matcher(token[2]);//MsgID
				Matcher m_Class = p.matcher(SLClass);
				Matcher m_Level = p.matcher(SLLevel);
				if (m_MsgID.find() || m_Class.find() || m_Level.find()){
					exists = true;
					dropit = true;
				}
				/*
				else {
					SQLDBcommunication.lock();
					//Checks if there exists already an entry 
					//in the logtable with the same parameters. 
					//It can happen if a log message arrives
					//more than one time.
					ResultSet result_sql = SQLDBcommunication.getResultsFromDB("" +
							"SELECT * FROM `dsnlog`WHERE " +
							"`DSNID` = '"+DSNID+"' " +
							" AND `MsgID` = "+MsgID+
							" AND `BootCount` = "+CmdParserLogging.DSN.get(DSNID).BootCount+" " +
							" AND `DSNtime` = "+SLTime+" "+
							" LIMIT 0 , 1");
					try {
						if (result_sql.next()){
							exists = true; dropit = true;
							int index = DSN.get(DSNID).request.indexOf(MsgID);
							if (index != -1){
								DSN.get(DSNID).request.remove(index);
							}
						}
					} catch (SQLException e) {}
					SQLDBcommunication.unlock();
				}
				*/
				
				//if there not exists an entry in de table 
				//with the same parameters.
				if (!exists){
					//genarates the Hashtable DSN if 
					//it doesn't exist already.
					if (!DSN.containsKey(DSNID)){
						dsn input = new dsn();
						DSN.put(DSNID,input);
						if (GetProperty.get("reboot_node").equals("yes")){
							DSN.get(DSNID).received.add(1);
							DSN.get(DSNID).request.add(1);
						}
					}
					
					//If DSN.log is empty that means that the last
					//log message was written to the db properly and
					//a new log message will begin.
					//(DSN.log will be cleared after a log message
					//arived properly)
					if (DSN.get(DSNID).log.isEmpty()){
						//the first log messages fragemnt must have the 
						//FragNr = 1, otherwise this package is lost and 
						//and this and the following arriving package
						//with the same MsgID will be droped.
						//If every thing is okey with the FragNr, the 
						//parameters out of the header are stored. 
						if (Integer.parseInt(FragNr)==1){
							DSN.get(DSNID).log.put("DSNID",DSNID);
							DSN.get(DSNID).log.put("MsgID",MsgID);
							DSN.get(DSNID).log.put("FragNr",FragNr);
							DSN.get(DSNID).log.put("DSNtime",SLTime);
							DSN.get(DSNID).log.put("Class",SLClass);
							DSN.get(DSNID).log.put("Level",SLLevel);
							DSN.get(DSNID).log.put("LogText",LineT);
							Date dt = new Date();
							DSN.get(DSNID).lastlogtime = dt.getTime();
							dropit = false;
						
						}
						//As mentioned before the package will be droped
						//and the already stored of a not terminated
						//package will be deleted as well. 
						else {
							dropit = true;
							if (!DSN.get(DSNID).request.contains(MsgID)){
								DSN.get(DSNID).request.add(MsgID);
								DSN.get(DSNID).log.clear();
							}
						}
					}
					
					//there is already a log message stored. 
					//but it could be that the last fragment of a log 
					//message is lost and there arrives already the
					//next log message. Therefore the MsgID must be the 
					//same.
					else if (DSN.get(DSNID).log.get("MsgID").equals(MsgID)){
						//the FragNr of the new log message must be 
						//just one larger than the stored FragNr, 
						//otherwise the message will be 
						//dropped and has to be requested again. 
						if (Integer.parseInt(FragNr) == Integer.parseInt((String)(DSN.get(DSNID).log.get("FragNr"))) +1){
							DSN.get(DSNID).log.put("FragNr", FragNr);
							dropit = false;
						}
						else {
							dropit = true;
							DSN.get(DSNID).request.add((Integer) DSN.get(DSNID).log.get("MsgID"));						
							DSN.get(DSNID).log.clear();
						}
					}
					
					//if the stored message ID is not the same
					//as the MsgID of the arrived log there must 
					//be lost a packet of the log with the stored
					//MsgID.
					else if (!DSN.get(DSNID).log.get("MsgID").equals(MsgID)){
						//if the MsgID of the new arrived paket
						//is equal to one, the params of the new
						//arrived packat will be stored and the
						//old log message which was stroed before 
						//will be requested again.
						if (Integer.parseInt(FragNr)==1){
							DSN.get(DSNID).request.add((Integer) DSN.get(DSNID).log.get("MsgID"));
							DSN.get(DSNID).log.put("DSNID",DSNID);
							DSN.get(DSNID).log.put("MsgID",MsgID);
							DSN.get(DSNID).log.put("FragNr",FragNr);
							DSN.get(DSNID).log.put("DSNtime",SLTime);
							DSN.get(DSNID).log.put("Class",SLClass);
							DSN.get(DSNID).log.put("Level",SLLevel);
							DSN.get(DSNID).log.put("LogText",LineT);
							dropit = false;
						}
						//if the FragNr of the new arrived log packet
						//is not equal to one, both of the MsgNr's will 
						//be requested again and the stored parameters
						//will be deleted. 
						else {
							DSN.get(DSNID).request.add((Integer) DSN.get(DSNID).log.get("MsgID"));
							DSN.get(DSNID).request.add(MsgID);
							DSN.get(DSNID).log.clear();
							dropit = true;
						}
					}
				}
			}
			else {dropit = true;}
		}
		
		
		else if ((end != -1) && (dropit == false)){ 
			/**********************************************
			 * If the line contains a 0x04 then it is
			 * going into this section.
			 * \x04 says that this line is the last line of 
			 * a package and also the end of the message.  
			 * The log message will be stored to the DB and
			 * the stored parameters in DSN.log can be deleted.
			 * If the MsgID was in the DSN.request it can be
			 * deleted there otherwise the MsgID is added 
			 * to DSN.received.
			 **********************************************/			
			//System.out.println("State 2");
			
			LineT = DSN.get(DSNID).log.get("LogText") + line.substring(0,end);
			String realLogTime = dsnTime.getRealTime(SLTime);
			SQLDBcommunication.lock();
			SQLDBcommunication.sendQueryToDB("" +
					"INSERT INTO `dsnlog` " +
					"(`DSNID` , `MsgID` , `BootCount` , `DSNtime` , `time` , `Class` , `Level` , `LogText` )" +
					" VALUES ('" + DSNID + "', '" + MsgID + "', "+CmdParserLogging.DSN.get(DSNID).BootCount+", '" + SLTime + "', '" + realLogTime + "', '" + SLClass +
							"', '" + SLLevel + "', '" + LineT + "');");
			SQLDBcommunication.unlock();
			DSN.get(DSNID).log.clear();
			int index = DSN.get(DSNID).request.indexOf(MsgID);
			if (index != -1) {
				DSN.get(DSNID).request.remove(index);
				if (DSN.get(DSNID).requested.containsKey(MsgID)){
					DSN.get(DSNID).requested.remove(MsgID);
				}
			}
			else {
				DSN.get(DSNID).received.add(MsgID);
			}
			Parser.resetParserState();
		}
		
		
		
		else if ((br != -1) && (dropit == false)){ 
			/**********************************************
			 * If the line contains a 0x03  then it is
			 * going into this section.
			 * \x03 says that this line is the last line of 
			 * a package and the rest of the message will 
			 * follow in the next package.
			 * The log message will be added to the stored 
			 * parameters in DSN.log.
			 **********************************************/			
//System.out.println("State 3");

			LineT = DSN.get(DSNID).log.get("LogText") + line.substring(0,br);
			DSN.get(DSNID).log.put("LogText",LineT);
			Parser.resetParserState();
		}
		
		
		else if (dropit == false){
			/**********************************************
			 * If none of the tags (0x04 or 0x03) occure
			 * that means that was a newline in the log
			 * message and the next line will belong to 
			 * this line as well. 
			 **********************************************/			
//System.out.println("State 4");
			Parser.setParserState(this);
			LineT = DSN.get(DSNID).log.get("LogText") + line;
			DSN.get(DSNID).log.put("LogText",LineT);
		}
		else {Parser.resetParserState();}
		ThreadLogging.unlock();
	}
}
