package dsnserver;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

/**********************************************
 * It is for parsing the log messages 
 * which comes from all BTnodes and it 
 * will store it into the DB.
 * When the DB table has no entry of a specific 
 * node we will request all logs of this node. 
 * After that we are looking for the last msgID
 * an request all log messages which are newer 
 * than thea last msgID in the DB.
 * 
 * @author  kaltt
 **********************************************/
public class CmdParserLogging_old implements CmdParser{

	int SLClass;
	int SLLevel;
	String DSNID;
	String MsgID;
	String SLTime;
	String LogText;
	String LineT = "" ;
	String DBID;
	private Map occuredID;
	DSNtimetoTime dsnTime;
	boolean exists = false;

	
	public CmdParserLogging_old(DSNtimetoTime dsnTime) {	
		super();
		// TODO Auto-generated constructor stub
		occuredID = new HashMap();
		this.dsnTime = dsnTime;
	}

	
	@SuppressWarnings("unchecked")
	public void parseLine(String line){
		//line = line.trim();
		line = line.replaceAll("'","''");
		String lineDB = "";
		String[] token = line.split(" ");
		int end = line.indexOf(0x04);
		int br = line.indexOf(0x03);
		
		if (Parser.getParserState() != this){
//System.out.println("State 1");			
			/**********************************************
			 * If a :SL is detected it is going into this 
			 * section. Here it parses the variables 
			 * SLTime, SLClass and SLLevel,
			 * which are used afterwards.
			 * Additionally ParserState is set to ":SL" that
			 * the Parser knows that the next line is for 
			 * this CMDParser as well.
			 **********************************************/
			Parser.setParserState(this);
			//if (!(token[0].equals(":SL"))){System.exit(0);}
			if (token[1].length()<=5) {DSNID = CmdParserGetAddr.DSNpreAddr + token[1];}else {DSNID = token[1];}
			MsgID = token[2];
			SLTime = token[3];
			if (SLTime.contains(":")){
				SLTime = SLTime.replaceAll(":", "");
				SLTime = SLTime.trim();
			}

			SLClass = Integer.parseInt(token[4]);
			SLLevel = Integer.parseInt(token[5].trim());
			LineT = "";	
			
			SQLDBcommunication.lock();
			ResultSet result = SQLDBcommunication.getResultsFromDB("" +
					"SELECT *  FROM `dsnlog` " +
					"WHERE `DSNID` = '" + DSNID + "' " +
					"AND `MsgID` = " + MsgID + " " +
					"AND `DSNtime` =  '" + SLTime + "' " +
					"AND `Class` = " + SLClass + " " +
					"AND `Level` = " + SLLevel);
			try {
				if (result.next()){exists = true;}//System.err.println("true");}
				else {exists = false;}//System.err.println("false");}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			SQLDBcommunication.unlock();
						
		}
		
		
		else if (end != -1){ 
			/**********************************************
			 * If the line contains a 0x04  then it is
			 * going into this section.
			 * \x04 says that this line is the last line of 
			 * a package and also the end of the message.  
			 * If the log message existes only 
			 * of one package, we can INSERT the message 
			 * to the DB.
			 * If this last package of a log massage, which
			 * was containing of more than one package, 
			 * we have to update the DB row.
			 * In the Map occuredID we can find the last 
			 * row ID for a DNSID, which is used to update 
			 * the rigth row.  
			 **********************************************/			
//System.out.println("State 2");

			LineT = LineT + line.substring(0,end);
			if ((occuredID.containsKey(DSNID))&&(exists)){
				SQLDBcommunication.lock();
				ResultSet result = SQLDBcommunication.getResultsFromDB("" +
						"SELECT `LogText` FROM `dsnlog` " +
						"WHERE (`ID` = " + occuredID.get(DSNID) + ")");
				try {
					result.next();
					lineDB = result.getString("LogText");
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				SQLDBcommunication.unlock();
				SQLDBcommunication.sendQueryToDB("" +
						"UPDATE `dsnlog` SET " +
						"`LogText` = '" + lineDB + LineT + "' " +
						"WHERE `ID` =" +  occuredID.get(DSNID) + " ;");
				occuredID.remove(DSNID);
			}
			else if (!exists){
				String realLogTime = dsnTime.getRealTime(SLTime);
				SQLDBcommunication.sendQueryToDB("" +
						"INSERT INTO `dsnlog` " +
						"(`DSNID` , `MsgID` , `DSNtime` , `time` , `Class` , `Level` , `LogText` )" +
						" VALUES ('" + DSNID + "', '" + MsgID + "', '" + SLTime + "', '" + realLogTime + "', '" + SLClass +
								"', '" + SLLevel + "', '" + LineT + "');");
			}
			
			LineT = "";
			Parser.resetParserState();
		}
		
		
		
		else if (br != -1){ 
			/**********************************************
			 * If the line contains a 0x03  then it is
			 * going into this section.
			 * \x03 says that this line is the last line of 
			 * a package and the rest of the message will 
			 * follow in the next package.
			 * If this is the first package of a this log 
			 * message we have to INSERT a new row, otherwise
			 * we will UPDATE the rigth row, wich is indicated
			 * with the tupple in the Map occuredID.
			 **********************************************/			
//System.out.println("State 3");

			LineT = LineT + line.substring(0,br);
			if ((occuredID.containsKey(DSNID))&&(exists)){
				SQLDBcommunication.lock();
				ResultSet result = SQLDBcommunication.getResultsFromDB("" +
						"SELECT `LogText` FROM `dsnlog` " +
						"WHERE (`ID` = " + occuredID.get(DSNID) + ")");
				try {
					result.next();
					lineDB = result.getString("LogText");
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				SQLDBcommunication.unlock();
				if (!(lineDB.contains(LineT))){					
					SQLDBcommunication.sendQueryToDB("" +
							"UPDATE `dsnlog` SET " +
							"`LogText` = '" + lineDB + LineT + "' " +
							"WHERE `ID` =" +  occuredID.get(DSNID) + " ;");
				}
			}				
			else if (!exists){
				String realLogTime = dsnTime.getRealTime(SLTime);
				SQLDBcommunication.sendQueryToDB("" +
						"INSERT INTO `dsnlog` " +
						"(`DSNID` , `MsgID` , `DSNtime` , `time` , `Class` , `Level` , `LogText` )" +
						" VALUES ('" + DSNID + "', '" + MsgID + "', '" + SLTime + "', '" + realLogTime + "', '" + SLClass +
								"', '" + SLLevel + "', '" + LineT + "');");
				SQLDBcommunication.lock();
				ResultSet result = SQLDBcommunication.getResultsFromDB("" +
					"SELECT `ID` FROM `dsnlog` ORDER BY `ID` DESC LIMIT 0 , 1");
				try {
					result.next();
					DBID = result.getString("ID"); 
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}	
				SQLDBcommunication.unlock();
				occuredID.put(DSNID,DBID);
			}
			LineT = "";
			Parser.resetParserState();
		}
		
		
		else{
			/**********************************************
			 * If none of the tags (0x04 or 0x03) occure
			 * that means that was a newline in the log
			 * message and the next line will belong to 
			 * this line as well. 
			 **********************************************/			
//System.out.println("State 4");
			Parser.setParserState(this);
			LineT = LineT + line;
		}
	}
			
}