package dsnserver;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;


/**********************************************
 * It is responsible for the anwers of a comand
 * which was sent by rpcs. These anwsers are 
 * stroed to the table dsnrpcs. 
 * 
 * @author  kaltt
 **********************************************/
public class CmdParserRPCS implements CmdParser{

	String DSNID;
	String LineT;
	String lineDB;
	String DBID;
	boolean msgend = false;
	private Map occuredID;
	
	public CmdParserRPCS() {
		occuredID = new HashMap();
	}

	
	/**********************************************
	 * It is responsible for the lines which start
	 * with ":RP". the following line after the :RP
	 * is stored as text to the table dsnrpcs. 
	 *  
	 * @param String line
	 *
	 **********************************************/
	@SuppressWarnings("unchecked")
	public void parseLine(String line) {
		String[] token = line.split(" ");
		int end = line.indexOf(0x04);
		int br = line.indexOf(0x03);

		if (Parser.getParserState() != this && token.length==2){
			/**********************************************
			 * If a :RP is detected it is going into this 
			 * section. Here it parses the variable DSNID.
			 * Additionally ParserState is set to ":RP" that
			 * the Parser knows that the next line is for 
			 * this CMDParser as well.
			 **********************************************/
			Parser.setParserState(this);
			if (token[1].length()<=5) {DSNID = CmdParserGetAddr.DSNpreAddr + token[1].trim();}else {DSNID = token[1].trim();}
		}
		
		else if (end != -1){ 
//System.out.println("end != -1");			
			/**********************************************
			 * If the line contains a 0x04  then it is
			 * going into this section.
			 * 0x04 says that this line is the last line of 
			 * a package and also the end of the message.  
			 **********************************************/			
			LineT = LineT + line.substring(0,end);
			if (LineT.startsWith("null")){LineT = LineT.substring(4,LineT.length());}
			
			if (occuredID.containsKey(DSNID)){
//System.out.println("if;");
				SQLDBcommunication.lock();
				ResultSet result = SQLDBcommunication.getResultsFromDB("" +
						"SELECT `msg` FROM `dsnrpcs` " +
						"WHERE (`ID` = " + occuredID.get(DSNID) + ")");
				try {
					if(result.next()){
						lineDB = result.getString("msg");
					}
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				SQLDBcommunication.unlock();
				LineT = lineDB + LineT;
//System.out.println(LineT);				
				SQLDBcommunication.lock();
				SQLDBcommunication.sendQueryToDB("" +
						"UPDATE `dsnrpcs` SET " +
						"`msg` = '" + LineT + "' " +
						"WHERE `ID` =" +  occuredID.get(DSNID) + " ;");
				SQLDBcommunication.unlock();
				occuredID.remove(DSNID);
				
			}
			else {
//System.out.println("else;");
				SQLDBcommunication.lock();
				SQLDBcommunication.sendQueryToDB("" +
						"INSERT INTO `dsnrpcs` " +
						"(`DSNID` , `msg`)" +
						" VALUES ('" + DSNID + "', '" + LineT + "');");
				SQLDBcommunication.unlock();
			}
			Parser.resetParserState();
			msgend = true;
//System.out.println(LineT);			
		}
		
		else if (br != -1){ 
//System.out.println("br != -1");			
			/**********************************************
			 * If the line contains a 0x03  then it is
			 * going into this section.
			 * \x03 says that this line is the last line of 
			 * a package and the rest of the message will 
			 * follow in the next package.
			 **********************************************/			
			LineT = LineT + line.substring(0,br);
			if (LineT.startsWith("null")){LineT = LineT.substring(4,LineT.length());}

			if (occuredID.containsKey(DSNID)){
				SQLDBcommunication.lock();
				ResultSet result = SQLDBcommunication.getResultsFromDB("" +
						"SELECT `msg` FROM `dsnrpcs` " +
						"WHERE (`ID` = " + occuredID.get(DSNID) + ")");
				try {
					if(result.next()){
						lineDB = result.getString("msg");
					}
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				SQLDBcommunication.unlock();
				SQLDBcommunication.lock();
				SQLDBcommunication.sendQueryToDB("" +
							"UPDATE `dsnrpcs` SET " +
							"`msg` = '" + LineT + "' " +
							"WHERE `ID` =" +  occuredID.get(DSNID) + " ;");
				SQLDBcommunication.unlock();
			}
			else {
				SQLDBcommunication.lock();
				SQLDBcommunication.sendQueryToDB("" +
						"INSERT INTO `dsnrpcs` " +
						"(`DSNID` , `msg`)" +
						" VALUES ('" + DSNID + "', '" + LineT + "');");
				SQLDBcommunication.unlock();
				SQLDBcommunication.lock();
				ResultSet result = SQLDBcommunication.getResultsFromDB("" +
					"SELECT `ID` FROM `dsnrpcs` ORDER BY `ID` DESC LIMIT 0 , 1");
				try {
					result.next();
					DBID = result.getString("ID"); 
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}	
				SQLDBcommunication.unlock();
				occuredID.put(DSNID,DBID);
			}
//System.out.println(LineT);			
			LineT = "";
			Parser.resetParserState();
		}
		
		else{
//System.out.println("else end");			
			/**********************************************
			 * If none of the tags (0x04 or 0x03) occure
			 * that means that was a newline in the 
			 * message and the next line will belong to 
			 * this line as well. 
			 **********************************************/			
			Parser.setParserState(this);
			LineT = LineT + line;
			if (LineT.startsWith("null")){LineT = LineT.substring(4,LineT.length());}
			//System.out.println(LineT);			
		}
		
		
		/**********************************************
		 * Here are the messages parsed.
		 **********************************************/			
		if (msgend){

			if (LineT.startsWith("null")){LineT = LineT.substring(4,LineT.length());}
			String[] token2 = LineT.split(" ");
			if (LineT.startsWith("Local bt_addr")){
				//System.out.println(LineT);
			}
			else if (LineT.startsWith(":DT")){
				//System.out.println(LineT);
			}
			else if (Parser.cmdParserPattern.containsKey(token2[0])){
				((CmdParser)Parser.cmdParserPattern.get(token2[0])).parseLine(LineT);
			}
			
			msgend = false;
			LineT = "";
		}
//System.out.println(LineT);
	}
}
