package dsnserver;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

/**********************************************
 * It is for parsing the cmd replies 
 * which comes from all BTnodes and it 
 * will store it into the DB.
 * 
 * @author  kaltt
 **********************************************/
public class CmdParserTargetCommand implements CmdParser{

	private Map occuredID;
	String DSNID;
	String DBID;
	int cmdID;
	String LineT = "" ;

	
	public CmdParserTargetCommand() {
		super();
		// TODO Auto-generated constructor stub
		occuredID = new HashMap();
	}
	
	@SuppressWarnings("unchecked")
	public void parseLine(String line){
		//line = line.trim();
		line = line.replaceAll("'","''");
		String lineDB = "";
		String[] token = line.split(" ");
		int end = line.indexOf(0x04);
		int br = line.indexOf(0x03);

		
		if (Parser.getParserState() != this){
//System.out.println("State 1: " + line);			
			/**********************************************
			 * If a :DC is detected it is going into this 
			 * section. Here it parses the variables 
			 * DSNID and CmdID,
			 * which are used afterwards.
			 * Additionally ParserState is set to ":DC" that
			 * the Parser knows that the next line is for 
			 * this CMDParser as well.
			 **********************************************/
			Parser.setParserState(this);
			//if (!(token[0].equals(":SL"))){System.exit(0);}
			if (token[1].length()<=5) {DSNID = CmdParserGetAddr.DSNpreAddr + token[1];}else {DSNID = token[1];}
			cmdID = Integer.parseInt(token[2].trim());
		}		
		
		else if (end != -1){ 
			/**********************************************
			 * If the line contains a 0x04  then it is
			 * going into this section.
			 * \x04 says that this line is the last line of 
			 * a package and also the end of the message.  
			 * If the cmd reply existes only 
			 * of one package, we can INSERT the message 
			 * to the DB.
			 * If this last package of a cmd repy, which
			 * was containing of more than one package, 
			 * we have to update the DB row.
			 * In the Map occuredID we can find the last 
			 * row ID for a DNSID, which is used to update 
			 * the rigth row.  
			 **********************************************/			
//System.out.println("State 2: " + line);

			LineT = LineT + line.substring(0,end);
			if (occuredID.containsKey(DSNID)){
				SQLDBcommunication.lock();
				ResultSet result = SQLDBcommunication.getResultsFromDB("" +
						"SELECT `cmdReply` FROM `cmdReply` " +
						"WHERE (`ID` = " + occuredID.get(DSNID) + ")");
				try {
					result.next();
					lineDB = result.getString("cmdReply");
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				SQLDBcommunication.unlock();
				SQLDBcommunication.lock();
				SQLDBcommunication.sendQueryToDB("" +
						"UPDATE `cmdReply` SET " +
						"`cmdReply` = '" + lineDB + LineT + "' " +
						"WHERE `ID` =" +  occuredID.get(DSNID) + " ;");
				SQLDBcommunication.unlock();
				occuredID.remove(DSNID);
			}
			else{
				SQLDBcommunication.lock();
				SQLDBcommunication.sendQueryToDB("" +
						"INSERT INTO `cmdReply` " +
						"(`cmdID` , `DSNID` , `cmdReply`)" +
						" VALUES (" + cmdID + ", '" + DSNID + "', '" + LineT + "');");
				SQLDBcommunication.unlock();
			}
			LineT = "";
			Parser.resetParserState();
		}
		
		
		
		else if (br != -1){ 
			/**********************************************
			 * If the line contains a 0x03  then it is
			 * going into this section.
			 * \x03 says that this line is the last line of 
			 * a package and the rest of the message will 
			 * follow in the next package.
			 * If this is the first package of a this cmd 
			 * replay we have to INSERT a new row, otherwise
			 * we will UPDATE the rigth row, wich is indicated
			 * with the tupple in the Map occuredID.
			 **********************************************/			
//System.out.println("State 3: " + line);

			LineT = LineT + line.substring(0,br);
			if (occuredID.containsKey(DSNID)){
				SQLDBcommunication.lock();
				ResultSet result = SQLDBcommunication.getResultsFromDB("" +
						"SELECT `cmdReply` FROM `cmdReply` " +
						"WHERE (`ID` = " + occuredID.get(DSNID) + ")");
				try {
					result.next();
					lineDB = result.getString("cmdReply");
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				SQLDBcommunication.unlock();
				SQLDBcommunication.lock();
				SQLDBcommunication.sendQueryToDB("" +
						"UPDATE `cmdReply` SET " +
						"`cmdReply` = '" + lineDB + LineT + "' " +
						"WHERE `ID` =" +  occuredID.get(DSNID) + " ;");
				SQLDBcommunication.unlock();
			}
			else{
				SQLDBcommunication.lock();
				SQLDBcommunication.sendQueryToDB("" +
						"INSERT INTO `cmdReply` " +
						"(`cmdID` , `DSNID` , `cmdReply`)" +
						" VALUES (" + cmdID + ", '" + DSNID + "', '" + LineT + "');");
				SQLDBcommunication.unlock();
				SQLDBcommunication.lock();
				ResultSet result = SQLDBcommunication.getResultsFromDB("" +
					"SELECT `ID` FROM `cmdReply` ORDER BY `ID` DESC LIMIT 0 , 1");
				try {
					result.next();
					DBID = result.getString("ID"); 
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}	
				SQLDBcommunication.unlock();
				occuredID.put(DSNID,DBID);
			}
			LineT = "";
			Parser.resetParserState();
		}
		
		
		else{
			/**********************************************
			 * If none of the tags (0x04 or 0x03) occure
			 * that means that was a newline in the cmd
			 * reply and the next line will belong to 
			 * this line as well. 
			 **********************************************/			
//System.out.println("State 4: " + line);
			Parser.setParserState(this);
			LineT = LineT + line;
		}
	}


}
