package dsnserver;
//import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**********************************************
 * This class is for parsing the strings i
 * ncluding the time and for the calculation 
 * from DSNtime to Real time.
 * 
 * @author  kaltt
 **********************************************/
public class DSNtimetoTime extends Thread implements CmdParser {

	Date now = new Date();
	SimpleDateFormat df = new SimpleDateFormat( "yyyy-MM-dd HH:mm:ss" );
	long timeNowReal = 0;
	long timeOldReal = 0;
	long timeNowDSN = 0;
	long timeOldDSN = 0;
	static public long RealTime = 0;
	
	Communication myComm;

	public DSNtimetoTime(Communication comm) {
		myComm = comm;
		// TODO Auto-generated constructor stub
	}


	/**********************************************
	 * If appears a line which is starting with 
	 * ":DT" this function is responsible for 
	 * parsing it. 
	 * It stores the actual time of the arriving time 
	 * of the line and the DSNtime which was send. 
	 * This new stored times and the times which were 
	 * stored last time will be used for the time 
	 * calculation.
	 **********************************************/
	public void parseLine(String line){
		Pattern p = Pattern.compile(":DT [0-9]+");
		Matcher m = p.matcher(line.trim());
		if (m.find()){
			Date now = new Date();
			timeOldReal = timeNowReal;
			timeNowReal = now.getTime();;
			timeOldDSN = timeNowDSN;
			String[] token = line.split(" ");
			timeNowDSN = Long.parseLong(token[1].trim());
		}

	}

	
	/**********************************************
	 * Is used to calculate a real time out of
	 * a DSNtime. 
	 * It can just be done properly if there will 
	 * be regularly new DSNtime request.
	 * 
	 * After a reboot of the guinode the function gives 
	 * back "1970-01-01 00:00:00" till the server has two 
	 * new times for the calculation.
	 * 
	 * @param String DSNtimeStr (the time to convert)
	 * 	
	 * @return String time (real time YYYY-MM-dd hh:mm:ss)
	 **********************************************/	
	public String getRealTime(String DSNtimeStr) {
		try {
		if (DSNtimeStr.contains(":")){
			DSNtimeStr = DSNtimeStr.replaceAll(":", "");
			DSNtimeStr = DSNtimeStr.trim();
		}
			
		long DSNtime = Long.parseLong(DSNtimeStr.trim());

	
		// it can happen if there occured an 
		// overflow or the guinode has rebooted.
		if (timeOldDSN > timeNowDSN){
			return "1970-01-01 00:00:00";
		}
		else{
			if (timeOldDSN == 0){
				RealTime = 0;
			}
			else {
				RealTime = timeOldReal + ((timeNowReal-timeOldReal)/(timeNowDSN-timeOldDSN))*(DSNtime-timeOldDSN); 
			}		
			

			now.setTime(RealTime);		
			
			String time = df.format(now);//(Long.toString(RealTime))
			return time;
			}
		} catch (NumberFormatException e) {
			System.err.println("NumberFormatException: " + DSNtimeStr.trim());
			return "1970-01-01 00:00:00";
		}
	}
	
	
	/**********************************************
	 * Requests all x milliseconds a new DSNtime 
	 * from the DSNnode.
	 **********************************************/	
	public void run() {
		
//System.out.println("DSNtimetoTime Thread gestarted");
		while (true){	
			if (XmlRpcThreadSwitch.JawsTimeSwitch){
				try {
					myComm.lock();
					myComm.writeLine("dsn get time");
					myComm.unlock();
					sleep(Long.parseLong(GetProperty.get("getTime_Time")));
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			else{
				try {
					sleep(Long.parseLong(GetProperty.get("getTime_Time")));
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
	
}
