package dsnserver;

import testserver.DSNServer_TEST;


/**********************************************
 * This class is used to create a new thread
 * which continuously sends a command out to 
 * the DSN. 
 * 
 * @author  kaltt
 **********************************************/
public class ThreadCommand extends Thread {
	
	private Communication myComm;
	
	int threadSleepingTime;
	String threadCommand;
    
	
	/**********************************************
	 * @param
	 * myComm a reference to Communication<br>
	 * threadSleepTime the time the thread will sleep<br>
	 * threadCommand the command that will be sent 
	 **********************************************/
	public ThreadCommand(Communication myComm, int threadSleepingTime, String threadCommand) {
		this.myComm = myComm;
		this.threadSleepingTime = threadSleepingTime;
		this.threadCommand = threadCommand;
    }
	
	
	public void run() {
		while (true){
			if (  (threadCommand.equals("rpc 0 dsn ping") && XmlRpcThreadSwitch.DSNPingSwitch)
				||(threadCommand.equals("rpc 0 dsn version") && XmlRpcThreadSwitch.DSNVersionSwitch)
				||(threadCommand.equals("rpc 0 dsn get loc") && XmlRpcThreadSwitch.DSNLocationSwitch)
				||(threadCommand.equals("rpc 0 xbank get proginfo") && XmlRpcThreadSwitch.DSNProgInfoSwitch)
				||(threadCommand.equals("coninfo") && XmlRpcThreadSwitch.ConinfoSwitch)
				){
				try {
					DSNServer_TEST.threadSemaphore.acquire();
				} catch (InterruptedException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				myComm.lock();
				myComm.writeLine(threadCommand);
				myComm.unlock();
				//that not all thread commands are 
				//sent out at the same time, there is
				//a sleep(1000)
				try {
					sleep(1000);
				} catch (InterruptedException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				DSNServer_TEST.threadSemaphore.release();
				if (threadSleepingTime > 1000){
					try {
						sleep(threadSleepingTime-1000);
					} catch (InterruptedException e) {}
				}
			}
			else{
				try {
					sleep(threadSleepingTime);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}    
}
