package dsnserver;


import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.ListIterator;
import java.util.concurrent.Semaphore;

/**********************************************
 * This class is used to request the logs from 
 * the BTnode.
 * It looks which nodes are here by looking
 * to the dsninfo table and sends after some 
 * seconds a new log request to the next DSNnode
 * in the table.  
 * 
 * @author  kaltt
 **********************************************/
public class ThreadLogging extends Thread{

	public Communication myComm;
	private static Semaphore sem = new Semaphore(1, true);
	int MsgID = 0;

	public ThreadLogging(Communication myComm) {
		this.myComm = myComm;
	}
	
	/**********************************************
	 * Thirst of all, it looks which nodes has 
	 * resbonded to the last dsn ping. 
	 * Afterwards it is doing following for each node:<br>
	 * -it sends a new slog get.
	 *  (if before arrived a log it says that it
	 *   needs just the logs after the highest 
	 *   MsgNr it becames before)<br>
	 * -it goes through the list with the recived
	 *  MsgID and evalutes which MsgID's has to 
	 *  be requested additionaly.<br>
	 * -it requests the MsgId which are stored in 
	 *  the requested list.
	 **********************************************/	
	public void run(){
		
		String DSNIDnext = "";
		String MsgID;

		int olderTime_int =  2*Integer.parseInt(GetProperty.get("getDSN_Ping"));			
		String olderTime;
		
		//From milliseconds into HH:mm:ss  
		double hour_d = (Math.floor(olderTime_int/3600000));
		String hour = Double.toString(hour_d);
		hour = hour.substring(0,hour.length()-2);
		if (hour.length()<2){hour = "0" + hour;}
		double min_d = Math.floor((olderTime_int-3600000*hour_d)/60000);
		String min = Double.toString(min_d);
		min = min.substring(0,min.length()-2);
		if (min.length()<2){min = "0" + min;}
		double sec_d = Math.floor((olderTime_int-3600000*hour_d-60000*min_d)/1000);
		String sec = Double.toString(sec_d);
		sec = sec.substring(0,sec.length()-2);
		if (sec.length()<2){sec = "0" + sec;}
		olderTime = hour+min+sec;
		
		ResultSet result = null;
		//ResultSet result2 = null;

		while(true){
			if (XmlRpcThreadSwitch.LoggingSwitch){
				try {
					SQLDBcommunication.lock();
					result = SQLDBcommunication.getResultsFromDB("" +
						"SELECT `DSNID` FROM `dsninfo` " +
						"WHERE (`DSNlastSeen` > now() - " + olderTime + ")");
					int i = 0;
					String DSNID = "";	
					result.last();
					int size = result.getRow();
					result.beforeFirst();
					if (size>0){
						while ((result != null) && (result.next())){					
							DSNID = DSNID + result.getString("DSNID") + " ";
							i++;
						}
						SQLDBcommunication.unlock();
						String[] DSNIDn = DSNID.split(" ");
						for (int j=0;j<i;j++)
						{
							DSNIDnext = DSNIDn[j].trim();
							
							if (DSNIDnext!="" && !CmdParserLogging.DSN.isEmpty() && CmdParserLogging.DSN.containsKey(DSNIDnext) && !CmdParserLogging.DSN.get(DSNIDnext).received.isEmpty()){
//System.out.println("drin-update");	
								ThreadLogging.lock();
								updateRequestLog(DSNIDnext);
								ThreadLogging.unlock();
//System.out.println("draus-update");															
							}
							if (DSNIDnext!="" && !CmdParserLogging.DSN.isEmpty() && CmdParserLogging.DSN.containsKey(DSNIDnext) && !CmdParserLogging.DSN.get(DSNIDnext).request.isEmpty()){
//System.out.println("drin-request");													
								RequestLog(DSNIDnext);
//System.out.println("draus-request");																					
							}
							
							if (GetProperty.get("logMethod").equals("pull")){
								int index = 0;
								if (CmdParserLogging.DSN.containsKey(DSNIDnext)){
									index = CmdParserLogging.DSN.get(DSNIDnext).received.size();
								}
								if (index != 0){					
									MsgID = Integer.toString(CmdParserLogging.DSN.get(DSNIDnext).received.get(index-1));
									myComm.lock();
									myComm.writeLine("rpcs " + DSNIDnext + " slog get " + CmdParserGetAddr.DSNnodeAddr + " " + MsgID);
									myComm.unlock();
								}
								else{
									myComm.lock();
									myComm.writeLine("rpcs " + DSNIDnext + " slog get " + CmdParserGetAddr.DSNnodeAddr);
									myComm.unlock();
								}
								
								if (!CmdParserLogging.DSN.isEmpty() && CmdParserLogging.DSN.containsKey(DSNIDnext) ){
									Date dt = new Date();
									CmdParserLogging.DSN.get(DSNIDnext).lastlogtime = dt.getTime();
									sleep(Integer.parseInt(GetProperty.get("logging")));
									while( (dt.getTime()) < CmdParserLogging.DSN.get(DSNIDnext).lastlogtime ){
										dt = new Date();
										sleep(Integer.parseInt(GetProperty.get("logging")));
									}						
								}
								else {
									sleep(1000);
									if (!CmdParserLogging.DSN.isEmpty() && CmdParserLogging.DSN.containsKey(DSNIDnext) ){
										Date dt = new Date();
										CmdParserLogging.DSN.get(DSNIDnext).lastlogtime = dt.getTime();
										sleep(Integer.parseInt(GetProperty.get("logging")));
										while( (dt.getTime()) <  CmdParserLogging.DSN.get(DSNIDnext).lastlogtime ){
											dt = new Date();
											sleep(Integer.parseInt(GetProperty.get("logging")));
										}
									}
								}
							}
							else if (GetProperty.get("logMethod").equals("push")){
								sleep(Integer.parseInt(GetProperty.get("pushtime")));
							}
							else {
								System.out.println("Error in logMethod, is set to "+GetProperty.get("logMethod")+" (pull | push)");
								break;
							}
						}
					}
					else{
						SQLDBcommunication.unlock();
						sleep(2000);
					}
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			else{
				try {
					sleep(2000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	
	/**********************************************
	 *It goes through DSN.received and evalutes which
	 *MsgID between the lowest and the highest MsgID
	 *in the DSN.received miss and write them to 
	 *DSN.request.
	 **********************************************/	
	@SuppressWarnings("unchecked")
	public void updateRequestLog(String DSNID){
		Collections.sort(CmdParserLogging.DSN.get(DSNID).received);
		ListIterator<Integer> listItr = CmdParserLogging.DSN.get(DSNID).received.listIterator();
		while(listItr.hasNext()) {
			if (listItr.hasNext()){
				MsgID = listItr.next();			
				int i = 1;
//System.out.println(DSNID+" received: "+MsgID);			
				while(!CmdParserLogging.DSN.get(DSNID).received.contains(MsgID + i) && listItr.hasNext()){
	
					CmdParserLogging.DSN.get(DSNID).request.add((MsgID + i));
//System.out.println(DSNID+" request: "+ (MsgID + i));				
					i++;
				}
			}
		}
		CmdParserLogging.DSN.get(DSNID).received.clear();
		CmdParserLogging.DSN.get(DSNID).received.add(MsgID);
		
//List<Integer> request_cmp = new ArrayList(CmdParserLogging.DSN.get(DSNID).request);
//ListIterator<Integer> listItr2 = request_cmp.listIterator();
//System.out.println("R (" + DSNID + ":");		
//while(listItr2.hasNext()){
//	System.out.println(listItr2.next());
//}		

	}
	
	
	/**********************************************
	 *It requests all MsgID's which are in DSN.request. 
	 *If there is a sequence of following numbers, it 
	 *requests them thogether. 
	 **********************************************/	
	@SuppressWarnings("unchecked")
	public void RequestLog(String DSNID){
		List<Integer> request_cmp = new ArrayList(CmdParserLogging.DSN.get(DSNID).request);
		Collections.sort(request_cmp);
		ListIterator<Integer> listItr = request_cmp.listIterator();
//ListIterator<Integer> listItr2 = request_cmp.listIterator();
//System.out.println("Liste (" + DSNID + ":");		
//while(listItr2.hasNext()){
//	System.out.println(listItr2.next());
//}		
		int MsgID_old = listItr.next();
		
		if (!CmdParserLogging.DSN.get(DSNID).requested.containsKey(MsgID_old)){
			CmdParserLogging.DSN.get(DSNID).requested.put(MsgID_old,0);
		}
		if (CmdParserLogging.DSN.get(DSNID).requested.get(MsgID_old) >= Integer.parseInt(GetProperty.get("numRequest"))){
			try {
				RXTXComm.writeLog("Lost Log (ID: " + DSNID + " MsgID: " + MsgID_old + " tries: " + CmdParserLogging.DSN.get(DSNID).requested.get(MsgID_old) + ")");
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			CmdParserLogging.DSN.get(DSNID).requested.remove(MsgID_old);
			int index = CmdParserLogging.DSN.get(DSNID).request.indexOf(MsgID_old);
			if (index != -1){
				CmdParserLogging.DSN.get(DSNID).request.remove(index);
			}
		}
		else{
			int k = CmdParserLogging.DSN.get(DSNID).requested.get(MsgID_old) + 1;
			CmdParserLogging.DSN.get(DSNID).requested.put(MsgID_old,k);
		}
		
		int i = 1;
		while(listItr.hasNext()) {
			if (listItr.hasNext()){
				int MsgID_new = listItr.next();
				if (!CmdParserLogging.DSN.get(DSNID).requested.containsKey(MsgID_new)){
					CmdParserLogging.DSN.get(DSNID).requested.put(MsgID_new,0);
				}
//System.out.println("Requested MsgID: "+CmdParserLogging.DSN.get(DSNID).requested.get(MsgID_new));				
				if (CmdParserLogging.DSN.get(DSNID).requested.get(MsgID_new) >= Integer.parseInt(GetProperty.get("numRequest"))){
					try {
						RXTXComm.writeLog("Lost Log (ID: " + DSNID + " MsgID: " + MsgID_new + " tries: " + CmdParserLogging.DSN.get(DSNID).requested.get(MsgID_new) + ")");
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}					
					CmdParserLogging.DSN.get(DSNID).requested.remove(MsgID_new);
					int index = CmdParserLogging.DSN.get(DSNID).request.indexOf(MsgID_new);
					if (index != -1){
						CmdParserLogging.DSN.get(DSNID).request.remove(index);
					}
				}
				else{
					int k = CmdParserLogging.DSN.get(DSNID).requested.get(MsgID_new) + 1;
					CmdParserLogging.DSN.get(DSNID).requested.put(MsgID_new,k);
			
//System.out.println("Request (ID: " + DSNID + " MsgID: " + MsgID_new + " Requested: " + k + ")");
					if (MsgID_old!=0 && MsgID_old == MsgID_new-1){
						i++;
					}
					else{
						myComm.lock();
						myComm.writeLine("rpcs " + DSNID + " slog get " + CmdParserGetAddr.DSNnodeAddr + " " + Integer.toString(MsgID_old-i) + " " + Integer.toString(i));
						myComm.unlock();
						try {
							//ThreadLogging.unlock();
							sleep(200);
							//ThreadLogging.lock();
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
//System.out.println("rpcs " + DSNID + " slog get " + CmdParserGetAddr.DSNnodeAddr + " " + Integer.toString(MsgID_old-i) + " " + Integer.toString(i));				
						i = 1;
					}
					MsgID_old = MsgID_new;
				}
//				if (CmdParserLogging.DSN.get(DSNID).requested.containsKey(MsgID_new)){
//					if (CmdParserLogging.DSN.get(DSNID).requested.get(MsgID_new) > 3){
//						CmdParserLogging.DSN.get(DSNID).requested.remove(MsgID_new);
//						int index = CmdParserLogging.DSN.get(DSNID).request.indexOf(MsgID);
//						if (index != -1){
//							CmdParserLogging.DSN.get(DSNID).request.remove(index);
//						}
//						try {
//							RXTXComm.writeLog("Lost Log (ID: " + DSNID + " MsgID: " + MsgID + ")");
//						} catch (IOException e) {
//							// TODO Auto-generated catch block
//							e.printStackTrace();
//						}
//					}
//					else{
//						int k = CmdParserLogging.DSN.get(DSNID).requested.get(MsgID_new) + 1;
//						CmdParserLogging.DSN.get(DSNID).requested.put(MsgID_new,k);
//					}
//				}
//				else {
//					CmdParserLogging.DSN.get(DSNID).requested.put(MsgID_new,1);
//				}

			}
		}
		myComm.lock();
		myComm.writeLine("rpcs " + DSNID + " slog get " + CmdParserGetAddr.DSNnodeAddr + " " + Integer.toString(MsgID_old-i) + " " + Integer.toString(i));
		myComm.unlock();
		try {
			sleep(200);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
//System.out.println("rpcs " + DSNID + " slog get " + CmdParserGetAddr.DSNnodeAddr + " " + Integer.toString(MsgID_old-i) + " " + Integer.toString(i));		
	}
	
	public static void lock() {
		try {
			sem.acquire();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void unlock(){
		sem.release();
	}

}
