package dsnserver;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;

/**********************************************
 * A function wich is used as a XmlRpc function.
 * It gives back all rows of the coninfo table. 
 *
 * @author kaltt
 *
 **********************************************/
public class XmlRpcGetConinfo {

	public XmlRpcGetConinfo() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**********************************************
	* A function wich is used as a XmlRpc function.
	* It gives back all rows of the coninfo table.
	*
	* @param String Source_DSNID <br>
	* String Neighbor_DSNID <br>
	* String State (0: visible/not connected, 1: neighbor is slave, 2: neighbor is master, 3: connection error, all: if you want the rows of all entries)<br> 
	* String time_from (yyyy-MM-dd HH:mm:ss)<br>
	* String time_till (yyyy-MM-dd HH:mm:ss) 
	* int maxReply (maxReply = 0 is to get all back and will be ordered ascending, if you specify maxReply the order will be descending and will start with the latest entry)
	* 
	* @return Hashtable result (Keys: time SourceAddr NeighborAddr State rssi)
	* 
	**********************************************/
	public Vector getConinfo(String Source_DSNID, String Neighbor_DSNID, String State, String time_from, String time_till, int maxReply) {
		
		Vector<Hashtable> result = new Vector<Hashtable>();
		Hashtable<String,Object> t;
		boolean doitagain = true;
		int count = 0;
		
        String Source_DSNID_sql = "";
        if (!(Source_DSNID.equals("all"))){Source_DSNID_sql = " AND SourceAddr = '" + Source_DSNID + "' ";}
		
        String Neighbor_DSNID_sql = "";
        if (!(Neighbor_DSNID.equals("all"))){Neighbor_DSNID_sql = " AND NeighborAddr = '" + Neighbor_DSNID + "' ";}

        String State_sql = "";
        if (!(State.equals("all"))){State_sql = " AND State = '" + State + "' ";}

        String maxReply_sql = "";
        if (maxReply!=0){maxReply_sql = "ORDER BY `ID` DESC LIMIT 0 , " + Integer.toString(maxReply);}

		while (doitagain && count < 10){
			result.clear();
			SQLDBcommunication.lock();
			ResultSet result_sql = SQLDBcommunication.getResultsFromDB("" +
					"SELECT * FROM `dsnconinfo` " +
					"WHERE time >= '" + time_from + "' " +
					"AND time <= '" + time_till + "' " +
					Source_DSNID_sql + 
					Neighbor_DSNID_sql + 
					State_sql + maxReply_sql + ";");
	        if (result_sql != null){
				try {
					while (result_sql.next()) 
					{  
						t = new Hashtable<String,Object>();
						t.put("time", new String(result_sql.getString("time")));
						t.put("SourceAddr", new String(result_sql.getString("SourceAddr")));
						t.put("NeighborAddr", new String(result_sql.getString("NeighborAddr")));
						t.put("State", new String(result_sql.getString("State")));
						t.put("rssi", new String(result_sql.getString("rssi")));
						result.add(t);
					}
					if (!result_sql.next()){doitagain = false;}	
				}
				catch (NullPointerException e){
					try {
						RXTXComm.writeLog("< " + e.toString());
					} catch (IOException e1) {}
					doitagain = true;
					count++;
				} 
				catch (SQLException e) {
					try {
						RXTXComm.writeLog("< " + e.toString());
					} catch (IOException e1) {}
					doitagain = true;
					count++;
				}
				catch (Exception e){
					try {
						RXTXComm.writeLog("< " + e.toString());
					} catch (IOException e1) {}
					doitagain = false;	
				}
	        }
	        SQLDBcommunication.unlock();
		}
		return result;
	}
	
	
	/**********************************************
	* result = getConinfo(Source_DSNID, Neighbor_DSNID, State, time_from, time_till, 0);
	*
	* @param String Source_DSNID <br>
	* String Neighbor_DSNID <br>
	* String State (0: visible/not connected, 1: neighbor is slave, 2: neighbor is master, 3: connection error, all: if you want the rows of all entries)<br> 
	* String time_from (yyyy-MM-dd HH:mm:ss)<br>
	* String time_till (yyyy-MM-dd HH:mm:ss) 
	* 
	* @return Hashtable result (Keys: time SourceAddr NeighborAddr State rssi)
	* 
	**********************************************/
	@SuppressWarnings("unchecked")
	public Vector getConinfo(String Source_DSNID, String Neighbor_DSNID, String State, String time_from, String time_till) {
		Vector<Hashtable> result = new Vector<Hashtable>();
		result = getConinfo(Source_DSNID, Neighbor_DSNID, State, time_from, time_till, 0);
		return result;
	}
}
