package dsnserver;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;


/**********************************************
 * A function wich is used as a XmlRpc function.
 * It gives back all rows of the dsninfo table 
 * in the DB.
 *
 * @author kaltt
 *
 **********************************************/
public class XmlRpcGetDSN {

	XmlRpcGetDSN(){
		super();
	}
	
//	@SuppressWarnings("unchecked")
	
	/**********************************************
	 * A function wich is used as a XmlRpc function.
	 * It gives back all rows of the dsninfo table 
	 * in the DB.
	 *
	 * @param int order 
	 * (0 no order,
	 * 1(ascending) DSNID, 
	 * 2(descending) DSNID,
	 * 3(ascending) DSNversion , 
	 * 4(descending) DSNVersion,
	 * 5(ascending) DSNLocation, 
	 * 6(descending) DSNLocation,
	 * 7(ascending) DSNProgInfo, 
	 * 8(descending) DSNProgInfo,
	 * 9(ascending) DSNlastSeen, 
	 * 10(descending) DSNlastSeen)
	 * 
	 * @return Hashtable result (Keys: DSNID, 
	 * DSNVer, DSNLocation, DSNProgInfo, DSNlastSeen,
	 * NodeInfo)
	 * 
	 **********************************************/
	public Vector getDSN(int order) {
		boolean doitagain = true;
		int count = 0;
		Vector<Hashtable> result = new Vector<Hashtable>();
		Hashtable<String,Object> t;
		String sql_order = "";
		switch (order) {
	    	case 0: sql_order = "";break;
	    	case 1: sql_order = " ORDER BY `DSNID` ASC ";break;
	    	case 2: sql_order = " ORDER BY `DSNID` DESC ";break;
	    	case 3: sql_order = " ORDER BY `DSNVer` ASC , `DSNID` ";break;
	    	case 4: sql_order = " ORDER BY `DSNVer` DESC , `DSNID` ";break;
	    	case 5: sql_order = " ORDER BY `DSNLocation` ASC, `DSNID` ";break;
	    	case 6: sql_order = " ORDER BY `DSNLocation` DESC, `DSNID` ";break;
	    	case 7: sql_order = " ORDER BY `DSNProgInfo` ASC, `DSNID` ";break;
	    	case 8: sql_order = " ORDER BY `DSNProgInfo` DESC, `DSNID` ";break;
        	case 9: sql_order = " ORDER BY `DSNlastSeen` ASC, `DSNID` ";break;
        	case 10: sql_order = " ORDER BY `DSNlastSeen` DESC, `DSNID` ";break;
        	default: sql_order = "";break;
		}

		while (doitagain && count < 10){
			result.clear();
			SQLDBcommunication.lock();
			ResultSet result_sql = SQLDBcommunication.getResultsFromDB("SELECT * FROM `dsninfo`" + sql_order + ";");
	 
			if (result_sql != null){
				try {
					while (result_sql.next()) 
					{   	 		
						t = new Hashtable<String,Object>();
						t.put("DSNID", new String(result_sql.getString("DSNID")));
						t.put("BootCount", new String(result_sql.getString("BootCount")));
						t.put("DSNVer", new String(result_sql.getString("DSNVer")));
						t.put("DSNLocation", new String(result_sql.getString("DSNLocation")));
						t.put("DSNProgInfo", new String(result_sql.getString("DSNProgInfo")));
						t.put("DSNlastSeen", new String(result_sql.getTimestamp("DSNlastSeen").toString().substring(0,result_sql.getTimestamp("DSNlastSeen").toString().length()-2)));
						t.put("NodeInfo", new String(result_sql.getString("NodeInfo")));
						
						result.add(t);					
					}
					if (!result_sql.next()){doitagain = false;}	
				}
				catch (NullPointerException e){
					try {
						RXTXComm.writeLog("< " + e.toString());
					} catch (IOException e1) {}
					doitagain = true;
					count++;
				} 
				catch (SQLException e) {
					try {
						RXTXComm.writeLog("< " + e.toString());
					} catch (IOException e1) {}
					doitagain = true;
					count++;
				}
				catch (Exception e){
					try {
						RXTXComm.writeLog("< " + e.toString());
					} catch (IOException e1) {}
					doitagain = false;	
				}
			}
			SQLDBcommunication.unlock();
		}
		return result;
	}
	
	public Vector getDSN() {
		Vector result = new Vector();
		result = getDSN(0);
		return result;
	}
}
