package dsnserver;

import java.io.File;
import java.io.FilenameFilter;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.Vector;

/**********************************************
 * A function wich is used as a XmlRpc function.
 * It gives back all names of the .hex or .ihx 
 * file which are stored in the folder /hex.
 *
 * @author kaltt
 *
 **********************************************/
public class XmlRpcGetFileList {

	public XmlRpcGetFileList() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	
	/**********************************************
	 * A function wich is used as a XmlRpc function.
	 * It gives back all names of the .hex or .ihex 
	 * files which are stored in the folder /hex.
	 *
	 * @return Hashtable result (Keys: Filename)
	 * 
	 **********************************************/
	public Vector getFileList() {
		Vector<Hashtable> result = new Vector<Hashtable>();
		Hashtable<String,String> t;

		File dir = new File(GetProperty.get("hexPath"));
		FilenameFilter ff = new FilenameFilter() {
			public boolean accept(File dir, String name) {
				if ((name.endsWith(".hex"))||(name.endsWith(".ihex")))
					return true;
				return false;
			}
		};
		String[] hexFiles = dir.list(ff);
		Arrays.sort(hexFiles, String.CASE_INSENSITIVE_ORDER);
		if(hexFiles != null){
			for (int i = 0; i < hexFiles.length; i++) {
				t = new Hashtable<String,String>();
				t.put("Filename", hexFiles[i]);
				result.add(t);
			}
		}
		else{
			t = new Hashtable<String,String>();
			t.put("Filename", "empty");
		}
		
		return result;
	}
}
