package dsnserver;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;


/**********************************************
 * A function wich is used as a XmlRpc function.
 * It gives back all rows of the dsnrpcs table 
 * in the DB.
 *
 * @author kaltt
 *
 **********************************************/
public class XmlRpcGetRPCS {

	XmlRpcGetRPCS(){
		super();
	}
	
//	@SuppressWarnings("unchecked")
	
	/**********************************************
	 * A function wich is used as a XmlRpc function.
	 * It gives back all rows of the dsnrpcs table 
	 * in the DB.
 	 
 	 * @param String DSNID <br>
	 * String msg (it is looking for this String in the msg-field in the DB, if the String is "" it gives back all rows which correspond with the other clauses)<br> 
	 * String time_from (yyyy-MM-dd HH:mm:ss)<br>
	 * String time_till (yyyy-MM-dd HH:mm:ss) <br>
	 * int maxReply (maxReply = 0 is to get all back and will be ordered ascending, if you specify maxReply the order will be descending and will start with the latest entry)
	 *
	 * @return Hashtable result (Keys: time, DSNID, msg) 
	 * 
	 **********************************************/
	public Vector getRPCS(String DSNID, String msg, String time_from, String time_till, int maxReply) {
		Vector<Hashtable> result = new Vector<Hashtable>();
		Hashtable<String,Object> t;

        String msg_sql = "";
        if (!msg.equals("")){
        	msg_sql = " AND `msg` LIKE '%" + msg +"%' ";
        }
        
        String DSNID_sql = "";
        if (!(DSNID.equals("all"))){DSNID_sql = " AND DSNID = '" + DSNID + "' ";}
		
        String maxReply_sql = "";
        if (maxReply!=0){maxReply_sql = "ORDER BY `ID` DESC LIMIT 0 , " + Integer.toString(maxReply);}
		
		result.clear();
		SQLDBcommunication.lock();
		ResultSet result_sql = SQLDBcommunication.getResultsFromDB("" +
				"SELECT * FROM `dsnrpcs`" +
					"WHERE time >= '" + time_from + "'" +
					"AND time <= '" + time_till + "'" +
					msg_sql + 
					DSNID_sql + maxReply_sql + ";");
	 
		if (result_sql != null){
			try {
				while (result_sql.next()) 
				{   	 		
					t = new Hashtable<String,Object>();
					t.put("time", new String(result_sql.getString("time")));
					t.put("DSNID", new String(result_sql.getString("DSNID")));
					t.put("msg", new String(result_sql.getString("msg")));

					result.add(t);					
				}
			}
			catch (NullPointerException e){
				try {
					RXTXComm.writeLog("< " + e.toString());
				} catch (IOException e1) {}
			} 
			catch (SQLException e) {
				try {
					RXTXComm.writeLog("< " + e.toString());
				} catch (IOException e1) {}
			}
			catch (Exception e){
				try {
					RXTXComm.writeLog("< " + e.toString());
				} catch (IOException e1) {}
			}
		}
		SQLDBcommunication.unlock();
		return result;
	}
}
