package testserver;

import org.apache.xmlrpc.*;

import com.mysql.jdbc.ResultSet;
import com.sun.corba.se.spi.servicecontext.SendingContextServiceContext;
import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;

import dsnserver.CmdParserGetAddr;
import dsnserver.GetProperty;
import dsnserver.SQLDBcommunication;

import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Iterator;
import java.util.Vector;
import java.util.Hashtable;
import java.io.*;
import java.net.URL;
import java.util.Date;

public class XmlRpc_DSNServer {

    // the xml-rpc client
    XmlRpcClient client;

 
	public static void main (String args[]) throws Exception {
		if (args.length < 1) {
		    System.err.println ("Usage: java Client URL");
		} else {
			XmlRpc_DSNServer client = new XmlRpc_DSNServer (args[0]);
		    client.run ();
		}
	}


    /**
     *  Constructor
     */
	public XmlRpc_DSNServer (String urlstring) throws Exception {
//		client = new XmlRpcClient(url);
		URL url = new URL(urlstring);
		DefaultXmlRpcTransportFactory tf = new DefaultXmlRpcTransportFactory(url);
		tf.setBasicAuthentication("kaltt", "mypwd");
		client = new XmlRpcClient(url, tf);
	}


	//@SuppressWarnings("unchecked")
	public void run () {
		// prepare arguments of the rpc-call
	    Vector<Integer> args = new Vector<Integer>();
	    //args.add(new Integer(3));
	    try {

	    	// do the rpc
            Vector result = (Vector)client.execute("getDSN.getDSN", args);
            // interpret result
            System.out.println("Result of getDSN has "+result.size()+" elements.");
        	System.out.println("------------------------------------");
            Iterator iter = result.iterator();
            while(iter.hasNext()){
            	Hashtable t = (Hashtable)iter.next();
            	System.out.println("DSNID       = "+t.get("DSNID"));
              	System.out.println("DSNVer      = "+t.get("DSNVer"));
              	System.out.println("DSNLocation = "+t.get("DSNLocation"));
              	System.out.println("DSNProgInfo = "+t.get("DSNProgInfo"));
              	System.out.println("DSNlastSeen = "+t.get("DSNlastSeen"));
                System.out.println("------------------------------------");
            }   
	    } catch (IOException e) {
	        System.out.println("IO Exception: " + e.getMessage());
	    } catch (XmlRpcException e) {
	        System.out.println("Exception within XML-RPC: " + e.getMessage());
	    }
	    //Test getDBEvent	
		// prepare arguments of the rpc-call
	    Vector<Object> args3 = new Vector<Object>();
	    args3.add(new String("00:04:3f:00:01:04"));
	    //args3.add(new String((String)(CmdParserGetAddr.DSNnodeAddr)));
	    args3.add(new Integer(15));
	    args3.add(new Integer(0));
	    args3.add(new String("2006-05-24 13:00:00"));
	    Date now = new Date();	    
		SimpleDateFormat df = new SimpleDateFormat( "yyyy-MM-dd HH:mm:ss" );
		String time = df.format(now);
	    args3.add(new String(time));
	    System.out.println(time);
	    try {
	    	// do the rpc                            getDBEvent.getDBEvent
            Vector result3 = (Vector)client.execute("getDBEvent.getDBEvent", args3);
            //Vector result3 = (Vector)client.execute("authTest.authTest", args3);
            // interpret result
            System.out.println("Result of getDBEvent has "+result3.size()+" elements.");
        	System.out.println("------------------------------------");
            Iterator iter = result3.iterator();
            while(iter.hasNext()){
            	Hashtable t = (Hashtable)iter.next();
            	System.out.println("DSNID    = "+t.get("DSNID"));
              	System.out.println("DSNtime  = "+t.get("DSNtime"));
              	System.out.println("time     = "+t.get("time"));
              	System.out.println("Class    = "+t.get("Class"));
              	System.out.println("Level    = "+t.get("Level"));
              	System.out.println("DBtime   = "+t.get("DBtime"));
              	System.out.println("LogText  = "+t.get("LogText"));
                System.out.println("------------------------------------");
            }   
	    } catch (IOException e) {
	        System.out.println("IO Exception: " + e.getMessage());
	    } catch (XmlRpcException e) {
	        System.out.println("Exception within XML-RPC: " + e.getMessage());
	    }
	    // Test getFileList	
		// prepare arguments of the rpc-call
	    Vector<Object> args4 = new Vector<Object>();
	    try {
	    	// do the rpc                            
            Vector result4 = (Vector)client.execute("getFileList.getFileList", args4);
            // interpret result
            System.out.println("Result of getFileList has "+result4.size()+" elements.");
        	System.out.println("------------------------------------");
            Iterator iter = result4.iterator();
            int i = 1;
            while(iter.hasNext()){
            	Hashtable t = (Hashtable)iter.next();
            	System.out.println("Filename "+ i++ +" = "+t.get("Filename"));
            }
            System.out.println("------------------------------------");
	    } catch (IOException e) {
	        System.out.println("IO Exception: " + e.getMessage());
	    } catch (XmlRpcException e) {
	        System.out.println("Exception within XML-RPC: " + e.getMessage());
	    }

	    //Test uploadFile	
		// prepare arguments of the rpc-call
	    Vector<Object> args2 = new Vector<Object>();
	    args2.add(new String("test.hex"));
		File datei = new File("hex/tos2.blink.btnode3.hex");
	    //File datei = new File("hex/senso.btnode3.hex");
	    byte[] fby = null;
		try {
			fby = getBytesFromFile(datei);
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		String s = Base64.encode(fby);
		
	    args2.add(new String(s));
		//args2.add(new String("das ist ein test"));
	    String filename = "";
	    try {
			filename = (String)client.execute("uploadFile.uploadFile", args2);
            // interpret result
	    } catch (IOException e) {
	        System.out.println("IO Exception: " + e.getMessage());
	    } catch (XmlRpcException e) {
	        System.out.println("Exception within XML-RPC: " + e.getMessage());
	    }

	    //Test loadFile	
		// prepare arguments of the rpc-call
	    Vector<Object> args5 = new Vector<Object>();
	    //args5.add(new String("test.hex"));
	    System.out.println();
	    System.out.println("file to upload: " + filename);
	    System.out.println();
	    args5.add(new String(filename));
	    args5.add(new String("1"));
	    try {
			Vector result5 = (Vector) client.execute("loadFile.loadFile", args5);
            // interpret result
            System.out.println("Result of loadFile has "+result5.size()+" elements.");
        	System.out.println("------------------------------------");
            Iterator iter = result5.iterator();
            while(iter.hasNext()){
            	Hashtable t = (Hashtable)iter.next();
            	System.out.println("Error = "+t.get("err"));
            }
            System.out.println("------------------------------------");
            // If the output is "" or ":LH completed: 6958 lines read" 
            // then everything is okey,
            // otherwise there was an error during the transmission!
            // Which will be given back!
	    } catch (IOException e) {
	        System.out.println("IO Exception: " + e.getMessage());
	    } catch (XmlRpcException e) {
	        System.out.println("Exception within XML-RPC: " + e.getMessage());
	    }

	    for (int i=0;i<1000000000;i++){}
		//Test DSNCommand
		// prepare arguments of the rpc-call
	    Vector<Object> args7 = new Vector<Object>();
	    args7.add(new String("all"));
	    //args7.add(new String("tg set power on"));
	    args7.add(new String("tg set power on"));
	    try {
			String result7 = (String) client.execute("dsnCommand.dsnCommand", args7);
	    } catch (IOException e) {
	        System.out.println("IO Exception: " + e.getMessage());
	    } catch (XmlRpcException e) {
	        System.out.println("Exception within XML-RPC: " + e.getMessage());
	    }
	    for (int i=0;i<1000000000;i++){}

	    //Test Targetflash
		// prepare arguments of the rpc-call
	    Vector<Object> args8 = new Vector<Object>();
	    args8.add(new String("00:04:3f:00:00:f9"));
	    try {
			String result8 = (String) client.execute("targetFlash.targetFlash", args8);
			System.out.println("");
			System.out.println("TargetFlash Message: "+result8);	
	    } catch (IOException e) {
	        System.out.println("IO Exception: " + e.getMessage());
	    } catch (XmlRpcException e) {
	        System.out.println("Exception within XML-RPC: " + e.getMessage());
	    }

	    //Test DSNVerbosity
		// prepare arguments of the rpc-call
	    Vector<Object> args9 = new Vector<Object>();
	    args9.add(new String("00:04:3f:00:00:f9"));
	    args9.add(new Integer(17));
	    args9.add(new Integer(15));
	    try {
			String result9 = (String) client.execute("dsnVerbosity.dsnVerbosity", args9);
			System.out.println("");
			System.out.println("Set Verbosity!");	
	    } catch (IOException e) {
	        System.out.println("IO Exception: " + e.getMessage());
	    } catch (XmlRpcException e) {
	        System.out.println("Exception within XML-RPC: " + e.getMessage());
	    }

	    
	}	

	
	
	
	
	public static byte[] getBytesFromFile(File file) throws IOException {
	        InputStream is = new FileInputStream(file);
	    
	        // Get the size of the file
	        long length = file.length();
	    
	        // You cannot create an array using a long type.
	        // It needs to be an int type.
	        // Before converting to an int type, check
	        // to ensure that file is not larger than Integer.MAX_VALUE.
	        if (length > Integer.MAX_VALUE) {
	            // File is too large
	        }
	    
	        // Create the byte array to hold the data
	        byte[] bytes = new byte[(int)length];
	    
	        // Read in the bytes
	        int offset = 0;
	        int numRead = 0;
	        while (offset < bytes.length
	               && (numRead=is.read(bytes, offset, bytes.length-offset)) >= 0) {
	            offset += numRead;
	        }
	    
	        // Ensure all the bytes have been read in
	        if (offset < bytes.length) {
	            throw new IOException("Could not completely read file "+file.getName());
	        }
	    
	        // Close the input stream and return bytes
	        is.close();
	        return bytes;	        
	    }


}
